# NOTE: Derived from ./blib/lib/Decision/Markov.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Decision::Markov;

#line 316 "./blib/lib/Decision/Markov.pm (autosplit into ./blib/lib/auto/Decision/Markov/EvalCohStep.al)"
sub EvalCohStep {
  my $self = shift;
  my $cycle = shift;
  my $patients_left = 0;
  # Determine where everyone will go next cycle. Give them half credit
  # for where they are now.
  foreach my $state ($self->States) {
     $self->CumUtility($self->CumUtility + 
        0.5 * $state->NumPatients * 
        $self->_discount_utility($cycle,$state->Utility($cycle)));
     $state->DistributeCohort($cycle);
  }
  # Were there any changes or are we done?
  foreach my $state ($self->States) {
     $patients_left += abs($state->NewNumPatients - $state->NumPatients);
  }
  # If nobody's going to change, we're done. They've even gotten their
  # final half-credit already. Stop now.
  return 0 unless $patients_left;
  # Actually put everyone there. Give them half credit for where they
  # moved to.
  $cycle++;
  foreach my $state ($self->States) {
     $state->UpdateCohort();
     $self->CumUtility($self->CumUtility + 
                          0.5 * $state->NumPatients * 
           $self->_discount_utility($cycle,$state->Utility($cycle)));
  }
  return $patients_left;
}

# end of Decision::Markov::EvalCohStep
1;
