# NOTE: Derived from ./blib/lib/Decision/Markov.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Decision::Markov;

#line 349 "./blib/lib/Decision/Markov.pm (autosplit into ./blib/lib/auto/Decision/Markov/PrintCycle.al)"
# Try to determine whether we're in a Monte Carlo or cohort simulation
# and print a picture of the current cycle.
sub PrintCycle {
  my $self = shift;
  my $fh = shift;
  my $cycle = shift;
  my @states = $self->States;
  if ($self->PatientsLeft) {
    # This is a cohort simulation
    if ($cycle == 0) {
       # First time. Print a header
       # We want the output to look like this:
       # Cycle CumUtility  State1 State2 State3 State4 State5
       #  1      <util>      #      #      #      #      #   
       $fh->print("                           COHORT SIMULATION\n");
       my $header = "Cycle Utility";
       foreach (1 .. scalar(@states)) {
         $header .= " State$_";
       }
       $fh->print("$header\n");
    }
    $fh->printf("%-5d %7.2f", $cycle, $self->CumUtility);
    foreach (@states) {
      $fh->printf(" %6d", $_->NumPatients);
    }
    $fh->print("\n");
  } else {
    # Monte Carlo simulation
    if ($cycle == 0) {
       # First time. Set up the header
       $fh->print("                           MONTE CARLO SIMULATION\n");
       my $header = "Cycle Utility";
       foreach (1 .. scalar(@states)) {
         $header .= " State$_";
       }
       $fh->print("$header\n");
    }
    $fh->printf("%-5d %7.2f", $cycle, $self->CumUtility);
    foreach (@states) {
      if ($self->CurrentState eq $_) {
        $fh->printf(" %6s", "XXX");
      } else {
        $fh->printf(" %6s", "");
      }
    }
    $fh->print("\n");

  }
}

# end of Decision::Markov::PrintCycle
1;
