# NOTE: Derived from ./blib/lib/Decision/Markov.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Decision::Markov;

#line 399 "./blib/lib/Decision/Markov.pm (autosplit into ./blib/lib/auto/Decision/Markov/PrintMatrix.al)"
#  $model->PrintDiagram; ?

sub PrintMatrix {
  my $self = shift;
  my $fh = shift;
  my $codes = '123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
  my @codes = split(//,$codes);
  my @states = $self->States;
  # State key
  $fh->printf("%-5s %-50s %10s\n","State","Description","Utility");
  foreach (0..$#states) {
    my $utility = $states[$_]->Utility;
    $utility = "Fcn" if ref($utility);
    $fh->printf("%s%-4s %-50s %10f\n",
                $states[$_]->FinalState ? "*" : " ", $codes[$_],
                $states[$_]->Name, $states[$_]->Utility);
  }
  $fh->print("\n\n* = Absorbing state (no transitions from this state)\n\n");
  $fh->print("Discount rate for utilities: ",$self->DiscountRate,"\n\n");
  $fh->print("Transition Probability Matrix\n\n");
  # Prob matrix
  $fh->print("     ");
  foreach (0..$#states) {
    $fh->printf(" %5s",$codes[$_]);
  }
  $fh->print("\n");
  foreach my $r (0..$#states) {
    $fh->printf("%-5s",$codes[$r]);
    foreach my $c (0..$#states) {
      my $prob;
      if (defined($prob = $states[$r]->TransitionProb($states[$c]))) {
        $fh->printf(" %5.3f",$prob);
      } else {
        $fh->printf(" %5s","");
      }
    }
    $fh->print("\n");
  }
}

1;
# end of Decision::Markov::PrintMatrix
