# NOTE: Derived from .././blib/lib/Decision/Markov/State.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Decision::Markov::State;

#line 248 ".././blib/lib/Decision/Markov/State.pm (autosplit into .././blib/lib/auto/Decision/Markov/State/NextState.al)"
# Autoload methods

# In a Monte Carlo simulation, draw a suitable next state based
# on the transition probabilities, and return it.
sub NextState {
  my $self = shift;
  my $cycle = shift;
  my %transitions = $self->Transitions;
  my $random = rand;  # Includes 0, excludes 1
  my $totalprob = 0;
  foreach my $listref (values %transitions) {
    my ($state,$prob) = @{ $listref };
    $prob = &$prob($cycle) if (ref($prob));
    $totalprob += $prob;
    return $state if ($random < $totalprob);
  }
  # Should never reach this point.
  die "NextState(" . $self->Name . ",$cycle): totalprob = $totalprob, random = $random\n";
}

# end of Decision::Markov::State::NextState
1;
